#include <stdio.h>
#include <stdlib.h>
int nadjikraj(int s, int d, int* niz)
{
    for (int i = s + 1; i < d; i++)
    {
        niz[i] = 1;
        return i - 1;
    }
    return d - 1;
}
int main()
{
	int y,x,p,k,ivica=0,t;
	scanf("%d %d",&y,&x);
	int a[x][y];
	for(int i = 0;i<y;i++)
	{
		for(int j = 0;j<x;j++)
		{
			scanf("%d",&a[j][i]);
		}
	}
	int b[x];
	for(int i = 0;i<x;i++)b[i]=1;
	
	for(int  i = 0;i<y;i++)
	{
		for(int j = 0;j<x;j++)
		{
			if(a[j][i]==0)
			{
				p=j;
				k=nadjikraj(j,x,a[i]);
				j=k;
				if(p==0)
				{
				ivica=1;
				}
				else if(k==x-1)
				{
					ivica=3;
				}
				else
				{
					ivica=2;
				}
				
				t=0;
				
				for(int ii=p;ii<=k;ii++)
				{
					t=t+b[ii];
					b[ii]=0;
				}
				
				if(t % 2 == 0)
				{
					if(ivica==1)b[k+1]+=t;
					else if(ivica==3)b[p-1]+=t;
					else
					{
						b[p-1]+=t/2;
						b[k+1]+=t/2;
					}
				}
				else
				{
					if(ivica==1)b[k+1]+=t;
					else if(ivica==3)b[p-1]+=t;
					else
					{
						if((i+1)%2==0)
						{
						b[p-1]+=t/2;
						b[k+1]+=t/2+1;
						}
						else
						{
						b[p-1]+=t/2+1;
						b[k+1]+=t/2;
						}
					}
				}
			}
		}
	}
	for(int i = 0;i<x;i++)printf("%d ",b[i]);
	
}